import { __awaiter } from "tslib";
import { APP_INITIALIZER, InjectionToken } from "@angular/core";
import { isPromise } from "./helpers";
export const ORDERED_APP_INITIALIZER = new InjectionToken("Ordered Application Initializer");
export function orderedAppInitializer(appInits) {
    return () => __awaiter(this, void 0, void 0, function* () {
        for (const initializer of appInits) {
            const result = initializer();
            if (isPromise(result)) {
                yield result;
            }
        }
    });
}
export const ORDERED_APP_PROVIDER = {
    provide: APP_INITIALIZER,
    useFactory: orderedAppInitializer,
    deps: [ORDERED_APP_INITIALIZER],
    multi: true,
};
//# sourceMappingURL=ordered-initializer.js.map